Smart Proxy - Bug #6289

vmlinuz/initrd files corrupted during when multiple hosts created simultaneously
06/19/2014 02:28 PM - Dominic Cleal

Status: Closed

Priority: Normal

Assignee:

Category: TFTP

Target version: 1.6.0

Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1110378 Red Hat JIRA:

Pull request:

Description

Linked BZ describes a side effect of async downloads:

--- Additional comment from James Slagle on 2014-06-17 15:02:27 BST ---

i been able to reliably reproduce this now and | believe what triggers this is assigning a 2nd host to a host group before the
vmlinuz/initrd download has finished from the first host to host group assignment.

according to the foreman-proxy.log, the 2nd assignment causes an additional background task to get started to download the
files. You then have multiple downloads clobbering each other.

likewise for any subsequent assignment if there is already a download running.

I've attached my foreman-proxy.log. It doesn't show anything different really from a successful download, but you can at least
see it starting an additional download task before the first has even finished.

| end up with files that are much larger than they should be:

[root@staypuft boot]l# pwd
/var/lib/tftpboot/boot
[root@staypuft boot]# 11 -h

total 277M

—-rw-—r——r——.
—img
—rw—r——r-——.
—vmlinuz
—rw—r——r——.
—rw—r——r-——.

1

foreman-proxy

foreman-proxy

foreman-proxy
foreman-proxy

root 165M Jun

root 3.9M Jun

foreman-proxy 101M May
foreman-proxy 7.4M May

5 14:45 foreman-discovery-image-latest.el6.iso
5 14:45 foreman-discovery-image-latest.el6.iso

7 03:39 RedHat-7.0-x86_64-initrd.img
5 11:21 RedHat-7.0-x86_64-vmlinuz

Related issues:

Related to Smart Proxy - Feature #3034: TFTP file download should be synchron... New

Associated revisions

Revision d44cdd95 - 07/07/2014 07:01 AM - Dmitri Dolguikh

fixes #6289: avoids concurrent downloads of files with the same name and destination dir.

History

#1 - 06/19/2014 02:29 PM - Dominic Cleal
- Related to Feature #3034: TFTP file download should be synchronous and handle errors added

#2 - 06/23/2014 01:18 PM - Anonymous

- Status changed from Assigned to Ready For Testing

PR: https://github.com/theforeman/smart-proxy/pull/170
https://github.com/theforeman/smart-proxy/pull/170

#3 - 06/25/2014 07:20 AM - Dominic Cleal

https://github.com/theforeman/smart-proxy/pull/173

#4 - 07/07/2014 06:52 AM - Dominic Cleal

- translation missing: en.field_release set to 10

#5 - 07/07/2014 07:24 AM - Anonymous

- Target version changed from 1.8.1 to 1.8.0

#6 - 07/07/2014 07:41 AM - Anonymous
- Status changed from Ready For Testing to Closed
